/*
 * Chapter 17
 *
 * Adjusting the brightness of the LED on the PD7 pin of the microcontroller,
 * by linearly changing the duty ratio of the PWM
 */

#include "../Headers/main.h"

int main(void)
{
    //Initializing inputs and outputs
    IOInit();
	
    //Initialization of PWM
    PWMInit();

    //Start counting upwards
    bool cntr_up = true;

    //Infinite loop
    while (1)
    {
        //If PWM duty ratio increases
        if (cntr_up)
        {
            //If it is lower than MAX
            if (OCR2 < PWM_DUTY_MAX)
            {
                //Increase
                OCR2++;
            }

            //If it has reached the maximum
            else
            {
                //Change direction
                cntr_up = false;
            }
        }

        //If PWM duty ratio decreases
        else
        {
            //If it is larger than MIN
            if (OCR2 > PWM_DUTY_MIN)
            {
                //Decrease
                OCR2--;
            }

            //If it has reached the minimum
            else
            {
                //Change direction
                cntr_up = true;
            }
        }

        //Delay in order to make the changes visible
        _delay_ms(PWM_DELAY_MS);
    }

    return 0;
}