#include "../Headers/pwm.h"

void PWMInit()
{
	
	/*
	 * The PWM frequency (page 120 of the datasheet) fpwm=fclkIO/(N*510),
	 * where N is the division of the clock signal.
	 * From this N=fclkIO/fpwm*1/510, namely for a frequency around 10 kHz
	 * N=8e6/10e3*1/510=1.569 is required..
	 * There are only 1,8,64,256,1024 divisions in the microcontroller,
	 * by choosing N=1
	 * fpwm=15.686kHz
	 *
	 */

    //Clock signal division by N=1 for the Timer2
    cbi(TCCR2, CS22);
    cbi(TCCR2, CS21);
    sbi(TCCR2, CS20);
    //Non-negated PWM operation, the OC2 output is 0 if the counter is bigger than the threshold
    sbi(TCCR2, COM21);
    cbi(TCCR2, COM20);
    //Phase correct PWM mode
    cbi(TCCR2, WGM21);
    sbi(TCCR2, WGM20);
	
	/* Instead of the sbi() and cbi() functions,
	 * which are definied in the compat/deprecated.h file,
	 * we can set each bit with the following solution which is based
	 * on the following "or" connections:
	 * TCCR2 = TCCR2 | (0<<CS22) | (0<<CS21) | (1<<CS20);
	 * This is kind of messy, so its recommended to use the functions above.
	 */

}
